function y_out=PBPK_model(x_in)
global x t_index

x=(x_in);

load jacobian_index
 %options=odeset('RelTol', 10^(-8), 'AbsTol', 10^(-25),'JPattern', jacobian_index);
 options=odeset('JPattern', jacobian_index);
 
  [t,u]=ode15s(@RHS, [0 10^5], zeros(35,1)', options);  %SOLVING ODE
 
%  plots

% 
% figure(11)
% plot(t,u(:,1))
% title('CPT-11 in blood')
% axis([0 1200 0 3.5])
% hold on
% figure(12)
% plot(t,u(:,2))
% title('SN-38 in blood')
% axis([0 1200 0 3.5])
% hold on
% figure(13)
% plot(t,u(:,3))
% title('SN-38G in blood')
% axis([0 1200 0 3.5])
% hold on
% figure(14)
% plot(t,u(:,4))
% title('NPC in blood')
% axis([0 1200 0 3.5])
% hold on
% figure(15)
% plot(t,u(:,5))
% title('APC in blood')
% axis([0 1200 0 3.5])
% hold on

[t_last,thirtyfive]=size(u);
y_out=u(t_last,26:35); %output only the excretion amount (y_1,...,y_10)

end

function [ans]=RHS(t,u)
global x
    u=u';
    ans=h(x,u,t)';
end

function h=h(x,u,t)
%construct \mathcal{N}
N1=[56,1,11,26,57]; %i=1
N2=[[2:5]',[12:15]',[27:30]', ones(4,2)*57]; %i=2:5
N3=[[6:10]', ones(5,4)*57]; %i=6:10
N4=[[21:25]', ones(5,4)*57]; %i=11:15
N5=[16,36, ones(1,3)*57]; %i=16
N6=[17, 37, 41, 45, 57]; %i=17
N7=[18, 38, 44, ones(1,2)*57]; %i=18
N8=[19, 39, 42, ones(1,2)*57]; %i=19
N9=[20, 40, 43, ones(1,2)*57]; %i=20
N10=[[31:35]', ones(5,4)*57]; %i=21-25
%excretion numerical integral
N11=[[46:55]', ones(10,4)*57]; %i=25-35

N=[N1;N2;N3;N4;N5;N6;N7;N8;N9;N10;N11];

%construct \mathcal{M}
M1=[[6:10]', [16:20]', [21:25]', [31:35]', [46:50]']; %i=1-5
M2=[[1:5]', ones(5,4)*57]; %i=6-10
M3=[[36:40]', ones(5,4)*57]; %i=11-15
M4=[11,41, 42,43,51]; %i=16
M5=[12, 44, 52, 57, 57]; %i=17
M6=[13, 53, 57, 57, 57]; %i=18
M7=[14, 45, 54, 57,57]; %i=19
M8=[15,55,57,57,57]; %i=20
M9=[[26:30]', ones(5,4)*57]; %i=21-25
%excretion numerical integral
M10=ones(10,5)*57;

M=[M1;M2;M3;M4;M5;M6;M7;M8;M9;M10];

l=el(x,u,t);

%compute the right hand side
h=(l(N(:,1))+l(N(:,2))+l(N(:,3))+l(N(:,4))+l(N(:,5)))-(l(M(:,1))+l(M(:,2))+l(M(:,3))+l(M(:,4))+l(M(:,5)));

h(1:5)=h(1:5)/x(55);
h(6:10)=h(6:10)/(1000-x(55)-x(56)-x(57)-x(58));
h(11:15)=h(11:15)/x(56);
h(16:20)=h(16:20)/x(57);
h(21:25)=h(21:25)/x(58);
end

function l=el(x,u,t)
global t_index
% l(56) is l(0) in the paper
if t<x(60)
    l(56)=x(59)/x(60);
else
    l(56)=0;
end

l(1:5)=x(51)./x(1:5).*u(6:10);
l(6:10)=x(51)*u(1:5);
l(11:15)=((x(52)+x(53))./x(11:15)).*u(16:20);
l(16:20)=x(53)*u(1:5);
l(21:25)=x(52)*u(1:5);
l(26:30)=(x(54)./x(16:20)).*u(21:25);
l(31:35)=x(54)*u(1:5);
l(36:40)=(x(52)./x(6:10)).*u(11:15);

l(41)=(x(41)*x(46)*x(57))/((x(36)*x(11))/(x(21)*u(16))+1);
l(42)=(x(44)*x(49)*x(57))/((x(39)*x(11))/(x(21)*u(16))+1);
l(43)=(x(43)*x(48)*x(57))/((x(38)*x(11))/(x(21)*u(16))+1);
l(44)=(x(45)*x(50)*x(57))/((x(40)*x(12))/(x(22)*u(17))+1);
l(45)=(x(42)*x(47)*x(57))/((x(37)*x(14))/(x(24)*u(19))+1);

l(46:50)=x(26:30).*x(21:25).*u(1:5);
l(51:55)=(x(31:35).*x(21:25))./x(11:15).*u(16:20);

l(57)=0;  %use when you want to use zero

end